INCLUDE donnees.asm
EXTRN affbarre : FAR
public ujdepbar

ujdeplacementbarre SEGMENT

Assume CS:ujdeplacementbarre, DS:Data, SS:Pile

ujdepbar PROC FAR ; procedure de deplacement de la barre dans le mode un joueur
	
	push AX,BX,CX,DX 
	mov AL,0	;on entre la couleur noire et la position de la barre pour l'effacer
	mov DX,positionbarre1
	push AX,DX
	call AffBarre
	
mov BX,LARGEUR_BARRE	

	Mov DL,0FFh	;on attend qu'une touche soit tapee
	Mov AH,06
	int 21h

;on regarde si il s'agit d'une touche en minuscule
	cmp AL,'a'	
	jb finminuscule
	cmp AL,'z'
	ja finminuscule
	add AL,'A'-'a' ;si c'est le cas, on la passe en majuscule pour dimininuer ensuite le nombre de tests

finminuscule:
joueur1 :	cmp AL,'W'	;touche de deplacement vers le haut
		je avancehaut1
		cmp AL,'X'	;touche de deplacement vers le bas
		je avancebas1
	
	cmp AL,'Q'		;touche pour quitter
	je fin2
	jmp fin
	
avancehaut1:	cmp positionbarre1,2+pas_deplacement	;on regarde si la barre touche le bord superieur au prochain deplacement
	     	ja bordhaut1				;si la barre est en dessous du bord
	     	mov positionbarre1,1						;si la barre va toucher le bord, on la place juste dessus
	     	mov finbarre1,17			;on met de meme la fin de la barre  une distance LARGEUR_BARRE
	     	add finbarre1,BX			;du bord
	     	jmp fin
bordhaut1 :  	SUB positionbarre1,pas_deplacement	;si la barre est loin du bord,on soustrait  la position actuelle
	     	sub finbarre1,pas_deplacement		;la valeur du deplacement
	     	jmp fin

avancebas1: 	cmp finbarre1,318-pas_deplacement	;on regarde si la barre va toucher le bord au prochain deplacement
	    	jbe bordbas1				;si elle est au-dessus	
	    	mov positionbarre1,317			;si elle touche le bord on positionne le debut de la barre  une distance
	    	sub positionbarre1,BX			;egale  la largeur de la barre par rapport au bord inferieur 
	     	mov finbarre1,318 			;on positionne la fin de la barre sur le bord
	    	jmp fin

bordbas1 :  	ADD positionbarre1,pas_deplacement	;si la barre est loin du bord inferieur on deplace la barre
	    	add finbarre1,pas_deplacement		; de la valeur du pas de deplacement
	    	jmp fin

fin2:		mov quit,1				;on met la variable quit  1 pour signaler que l'on veut quitter
fin : 		pop AX,BX,CX,DX 
		ret

ujdepbar ENDP
ujdeplacementbarre ENDS
END
